/*
------------------------------------------------------------
   Kobo Deluxe - An enhanced SDL port of XKobo
------------------------------------------------------------
 * Copyright (C) 1995, 1996, Akira Higuchi
 * Copyright (C) 2001, David Olofson
 * 
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 2 of the License, or (at your
 * option) any later version.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef _KOBO_CONFIG_H_
#define _KOBO_CONFIG_H_

#include <aconfig.h>

#ifdef DEBUG
#	define	DBG(x)	x
#else
#	define	DBG(x)
#endif

#ifndef HAVE_SNPRINTF
#define snprintf _snprintf
#endif

#define	KOBO_KEY_DELAY	250
#define	KOBO_KEY_REPEAT	40

#ifndef WAIT_MSEC
#define WAIT_MSEC	30
#endif

#ifndef SHIPS
#define SHIPS		5
#endif

#define BEAM_MAX	10
#define ENEMY_MAX	1024

#define	INTRO_BLANK_TIME	1000
#define	INTRO_TITLE_TIME	4000
#define	INTRO_HIGHSCORE_TIME	7000
#define	INTRO_TITLE2_TIME	4000
#define	INTRO_CREDITS_TIME	7000

//#define WSIZE	224
//#define MARGIN	8
/*
 * Note that this adds 8 "partially" visible
 * pixels around the screen, which could mean
 * that some objects can be created or deleted
 * in view. Finding out whether or not it can
 * really happen calls for closer analysis of
 * the code.
 */
#define WSIZE	230
#define MARGIN	5

/*
 * NOTE:  I *DON'T* want to change the view
 *        range as the XKobo engine knows it,
 *        as that would make the game play
 *        slightly differently. (Probably not
 *        so that anyone would notice, but
 *        let's not take chances... This is
 *        NOT "Kobo II".)
 */
#define VIEWLIMIT	224

#define HIT_MYSHIP	5
#define HIT_BEAM	5

#define WSCORE_SIZEX	250
#define WSCORE_SIZEY	240

#define	SCREEN_WIDTH	320
#define	SCREEN_HEIGHT	240

#define	SCROLLER_SPEED	180

////////////////////////////////////////////////////////////////////////////

#define CHIP_SIZEX_LOG2   4
#define CHIP_SIZEY_LOG2   4
#define MAP_SIZEX_LOG2    6
#define MAP_SIZEY_LOG2    7
#define WORLD_SIZEX_LOG2 (MAP_SIZEX_LOG2+CHIP_SIZEX_LOG2)
#define WORLD_SIZEY_LOG2 (MAP_SIZEY_LOG2+CHIP_SIZEY_LOG2)

#define CHIP_SIZEX        (1<<CHIP_SIZEX_LOG2)
#define CHIP_SIZEY        (1<<CHIP_SIZEY_LOG2)
#define MAP_SIZEX         (1<<MAP_SIZEX_LOG2)
#define MAP_SIZEY         (1<<MAP_SIZEY_LOG2)
#define WORLD_SIZEX      (1<<WORLD_SIZEX_LOG2)
#define WORLD_SIZEY      (1<<WORLD_SIZEY_LOG2)

#endif	//_KOBO_CONFIG_H_
